#include"swr_point.hpp"
#include<cstdio>
#include<cmath>




namespace swr{


void
Point::
reset(int  x_, int  y_, int  z_)
{
  x = x_;
  y = y_;
  z = z_;
}


Point  Point::operator+(const Point&  rhs) const{return Point(x+rhs.x,y+rhs.y,z+rhs.z);}
Point  Point::operator-(const Point&  rhs) const{return Point(x-rhs.x,y-rhs.y,z-rhs.z);}


Point&
Point::
operator+=(const Point&  rhs)
{
  x += rhs.x;
  y += rhs.y;
  z += rhs.z;

  return *this;
}


Point&
Point::
operator-=(const Point&  rhs)
{
  x -= rhs.x;
  y -= rhs.y;
  z -= rhs.z;

  return *this;
}


bool
Point::
operator==(const Point&  rhs) const
{
  return((x == rhs.x) &&
         (y == rhs.y) &&
         (z == rhs.z));
}


void
Point::
print() const
{
  printf("[print Point] X:%4d, Y:%4d, Z:%4d\n",x,y,z);
}




}




