#include"swr_polygon.hpp"
#include"swr_vector.hpp"




namespace swr{




Polygon&
Polygon::
operator+=(const Point&  offset)
{
  a_point += offset;
  b_point += offset;
  c_point += offset;

  return *this;
}


Polygon&
Polygon::
operator-=(const Point&  offset)
{
  a_point -= offset;
  b_point -= offset;
  c_point -= offset;

  return *this;
}


void
Polygon::
modify(const Point&  offset, const RotationParameter&  rotparam)
{
  *this += offset;

  rotparam.rotate(a_point);
  rotparam.rotate(b_point);
  rotparam.rotate(c_point);
}


SortedPolygon
Polygon::
to_sorted() const
{
  const Point&  a = a_point;
  const Point&  b = b_point;
  const Point&  c = c_point;

    if(a.y > b.y)
    {
        if(a.y > c.y)
        {
            if(b.y > c.y){return SortedPolygon(color,a,b,c);}
          else           {return SortedPolygon(color,a,c,b);}
        }

      else
        {
          return SortedPolygon(color,c,a,b);
        }
    }

  else
    if(b.y > c.y)
    {
        if(a.y > c.y){return SortedPolygon(color,b,a,c);}
      else           {return SortedPolygon(color,b,c,a);}
    }


  return SortedPolygon(color,c,b,a);
}


Vector
Polygon::
get_vector() const
{
  Vector  v0(a_point,b_point);
  Vector  v1(b_point,c_point);

  auto  v = Vector::cross_product(v0,v1);

  return v;
}


void
Polygon::
print() const
{
  a_point.print();
  b_point.print();
  c_point.print();
}



}




