#include"swr_polygonrenderer.hpp"
#include"swr_linecontext.hpp"
#include"swr_lineparameter.hpp"
#include<cstdio>
#include<cstring>




namespace swr{




namespace{
bool
advance(LineContext&  ctx, int  y)
{
    for(;;)
    {
        if(ctx.get_y() == y)
        {
          return true;
        }


        if(!ctx.step())
        {
          break;
        }
    }


  return false;
}
}


PolygonRenderer::
PolygonRenderer(const SortedPolygon&  src, const Screen&  scr)
{
    if(!src.test())
    {
      printf("error\n");

      return;
    }


  LineContext  ctx0(src.lowest,src.highest);
  LineContext  ctx1(src.lowest,src.middle);

    for(int  y = src.lowest.y;  y < src.middle.y;  ++y)
    {
      auto  res0 = advance(ctx0,y);
      auto  res1 = advance(ctx1,y);

        if(!res0 ||
           !res1)
        {
          break;
        }


      LineParameter(src.color,ctx0.get_point(),
                              ctx1.get_point()).render(scr);
    }


  ctx1.reset(src.middle,src.highest);

    for(int  y = src.middle.y;  y <= src.highest.y;  ++y)
    {
      auto  res0 = advance(ctx0,y);
      auto  res1 = advance(ctx1,y);

        if(!res0 ||
           !res1)
        {
          break;
        }


      LineParameter(src.color,ctx0.get_point(),
                              ctx1.get_point()).render(scr);
    }
}


}




